# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetTlsVersionsResult',
    'AwaitableGetTlsVersionsResult',
    'get_tls_versions',
    'get_tls_versions_output',
]

@pulumi.output_type
class GetTlsVersionsResult:
    """
    A collection of values returned by getTlsVersions.
    """
    def __init__(__self__, id=None, result_output_file=None, tls=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)
        if tls and not isinstance(tls, list):
            raise TypeError("Expected argument 'tls' to be a list")
        pulumi.set(__self__, "tls", tls)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")

    @property
    @pulumi.getter
    def tls(self) -> Sequence['outputs.GetTlsVersionsTlResult']:
        """
        TLS key value.
        """
        return pulumi.get(self, "tls")


class AwaitableGetTlsVersionsResult(GetTlsVersionsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetTlsVersionsResult(
            id=self.id,
            result_output_file=self.result_output_file,
            tls=self.tls)


def get_tls_versions(result_output_file: Optional[str] = None,
                     opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetTlsVersionsResult:
    """
    Use this data source to query detailed information of waf tls_versions

    ## Example Usage

    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    example = tencentcloud.Waf.get_tls_versions()
    ```


    :param str result_output_file: Used to save results.
    """
    __args__ = dict()
    __args__['resultOutputFile'] = result_output_file
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
    __ret__ = pulumi.runtime.invoke('tencentcloud:Waf/getTlsVersions:getTlsVersions', __args__, opts=opts, typ=GetTlsVersionsResult).value

    return AwaitableGetTlsVersionsResult(
        id=__ret__.id,
        result_output_file=__ret__.result_output_file,
        tls=__ret__.tls)


@_utilities.lift_output_func(get_tls_versions)
def get_tls_versions_output(result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                            opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetTlsVersionsResult]:
    """
    Use this data source to query detailed information of waf tls_versions

    ## Example Usage

    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    example = tencentcloud.Waf.get_tls_versions()
    ```


    :param str result_output_file: Used to save results.
    """
    ...
